package colls

import scala.language.higherKinds
import annotation.effects._
import scala.io.Source
import scala.annotation.tailrec
import org.scalameter._



object Main{
  def fakePrint(s: String) = s
  def readM = {
    10
  }

  def time[R](block: => R): R = {
    val t0 = System.nanoTime()
    val result = block    // call-by-name
    val t1 = System.nanoTime()
    println("" + (t1 - t0)/1000000000.0 + "")
    result
  }

  object A{
    def rr = readM
  }
  def main(args: Array[String]): Unit= {
    /*def g(f: Int => Int): Int @pure = {
      def h() = {
        f(10) : @pure(f)
      }
      h()
    }
    def ll(x: Int): Int @simpleOutput = x
    g(ll _) : @pure
    */
    val warmup = 100000
    val reps = 1000000
    /*for(i <- 1 to warmup){
      doitNoEffects()
    }*/
    val fun = doitNoEffects _

    /*withWarmer {
      new Warmer.Default
    }*/
    /*
    val tt = config(
      Key.exec.benchRuns -> 1,
      Key.verbose -> false
    )  withMeasurer {
      new Measurer.IgnoringGC
    } measure {
      for (i <- 0 until reps) yield fun()
    }
    println("" + tt/1000.0 + "")
    */
    for(i <- 1 to warmup){
      doitNoEffects()
    }


    time{
      for(i <- 0 to reps){
        doitNoEffects()
      }
    }

  }
  def doitNoEffects(): Unit  = {
    def invalid(x: Int): Int = { x}
    /*

    def gg(f: (Int => Int) { def apply(x: Int): Int @unknown}) = {
      f(10)
    }
    gg(invalid _)*/



    def guess = {
      doUInt
      doWW(10)
    }

    def doUInt: Int = 10
    def doWW(x: Int): Int  = {
      //doUInt
      x
    }



    def gWriteUnk(x: Int): Int = {
      doWW(1)
    }

    //Source.fromFile("test.txt")

    {
      fakePrint("hola")
    }

    fakePrint("oa")

    gWriteUnk(10)

    readM

    def ppp: Int  = {
      readM
    }

    ppp //3

    A.rr



    type ReadAndAlloc = (Int => Int) { def apply(x: Int): Int }
    def h(f: ReadAndAlloc): Int   = {
      f(1)
      1
    }

    def gRead(x: Int) = {
      if(true)
        doUInt
      else
        1
      2
    }

    h(gRead _) //4

    h((x: Int) => gRead(x)) //5


    @tailrec
    def myMap(l: List[Int], fh: Int => Int, acc: List[Int]): List[Int]  = {
      l match{
        case Nil => Nil
        case x :: xs => myMap(xs, fh, fh(x) :: acc)
      }
    }


    def gg(f: (Int => Int) { def apply(x: Int): Int}): Int  = {
      f(10)
    }

    def bla() = {

      def gg(f: (Int => Int) { def apply(x: Int): Int }): Int  = {
        f(10)
      }
      gg _

    }

    //gg(invalid _)

    //bla()(invalid _)



    myMap((1 to 50).toList,  x => x+1, List()) //0

    myMap((1 to 30).toList,  x => {doWW(x) }, List()) //35

    myMap((1 to 30).toList,  gWriteUnk _ , List()) //65

    myMap(List(),  gWriteUnk _ , List()) //0


    class A{
      def ff(x: Int): Int  = {
        x
      }
    }

    class B extends A{
      override def ff(x: Int): Int = x
    }

    fakePrint("ok")

    val b = new B
    def blip(a: A)  = {
      a.ff(10)
    }

    //blip(new A)

    //blip(new A)
    //blip(b)
    //caso que falla:
    /*case class Foo(id: Int)

    object Foo{
      val x = Foo.apply _
    }*/
    //guess

    class BaseClass{
      def fun(x: Float): Unit = {

      }
    }
    class C extends BaseClass{
      override def fun(x: Float): Unit = {
        doUInt
      }
    }
    val c: BaseClass  = new C
    for{i <- 1 to 30}{
      c.fun(10) //95
    }

    val list = (1 to 100).toArray
    list.map(x => x+1)

  }















}