#!/bin/bash

die () {
    echo >&2 "$@"
    exit 1
}

[ "$#" -eq 1 ] || die "Argument required: target folder"

base=$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )

mkdir -p $1/lib

ln -sf $base/efftp/target/scala-2.10/effects-plugin_2.10-0.1-SNAPSHOT.jar $1/lib/infer.jar
echo -e "[\033[32msuccess\033[0m] Symbolic link created: $base/efftp/target/scala-2.10/effects-plugin_2.10-0.1-SNAPSHOT.jar -> $1/lib/infer.jar"

ln -sf $base/gpes/target/scala-2.10/effects-checker-plugin_2.10-0.1-SNAPSHOT.jar $1/lib/check.jar
echo -e "[\033[32msuccess\033[0m] Symbolic link created: base/gpes/target/scala-2.10/effects-checker-plugin_2.10-0.1-SNAPSHOT.jar -> $1/lib/check.jar"
