package interpreter

import tools._
import interpreter._
import parser._

class LatticeSectionInfer(salida : java.io.PrintStream) {

  var tools=new Tools()
	
  	def lattice(name:Name, privileges:Privilegios, lattice:Lattice){
	  salida.println("abstract class "+name.name+"Lattice extends EffectLattice {")
	  salida.println("val global: Global")
	  salida.println("import global._")
	  valprivClass(privileges)
	  salida.println()
	  salida.println("lazy val nothingType = definitions.NothingClass.tpe")
	  salida.println()
	  salida.println("type Effect = "+name.name+"Effect")
	  salida.println("val ctEvidence = implicitly[scala.reflect.ClassTag[Effect]]")
	  classExampleType(name)
	  lteOneTps()
	  clases(name, privileges, lattice)
	  caseClassDominioEffect(name)
	  	  salida.println()
	  objectDominioEffect(name)	  
	  lazyTop(name, privileges, lattice)
	  	  salida.println()
	  lazybottom(name, privileges, lattice)
	  	  salida.println()
	  lazyUnknown(name, privileges, lattice)
	  	  salida.println()
	  defDefault()
	  	  salida.println()
	  defLte()
	  	  salida.println()
	  defLteOne(name, lattice)
	  	  salida.println()
	  defLteOneOne(name)
	  	  salida.println()
	  elimSub(name)
	  	  salida.println()
	  revoke(name)
	  	  salida.println()
	  join(name:Name)
	  	salida.println()
	  meet(name:Name)
	  	salida.println()
	  diff(name:Name)
	  	salida.println()
	  getStrictPrivileges(name:Name)
//	  getStrictPrivilegesTree(name, privileges)
	  salida.println("}")
	}
  
  // -----Para   "lazy val readeClass = rootMirror.getClassByName(newTypeName("scala.annotation.effects.reade"))"...
  private def valprivClass(privileges:Privilegios){
    for(i<- 0 to privileges.privs.length-1)
      salida.println("lazy val "+privileges.privs.apply(i).anot.anot.tipo+"Class = rootMirror.getClassByName(newTypeName("+"""""""+"scala.annotation.effects."+privileges.privs.apply(i).anot.anot.tipo+"""""""+"))")
  }

  // -----------------Para "abstract class ExampleType"----------------
  private def classExampleType(name:Name){
    salida.println("abstract class "+name.name+"Type{")
    salida.println("  def lte(b: "+name.name+"Type) = {")
    salida.println("b.getClass.isAssignableFrom(this.getClass)")
    salida.println("}")
    	salida.println()
    salida.println("def lteCovariant(aTp: Type, bTp: Type): Boolean = {")
    salida.println("  aTp <:< bTp")
    salida.println("}")
    	salida.println()
    salida.println("def lteContravariant(aTp: Type, bTp: Type): Boolean = {")
    salida.println("bTp <:< aTp")
    salida.println("}")
    	salida.println()
    salida.println("def lteInvariant(aTp: Type, bTp: Type): Boolean = {")
    salida.println("aTp =:= bTp")
    salida.println("}")
    	salida.println()
    salida.println("def lteCoContravarianza(aTp: Type, bTp: Type): Boolean = {")
    salida.println("aTp <:< bTp || bTp <:< aTp")
    salida.println("}")
    	salida.println()
    salida.println("}")
    
  }

  //---------------------def lteOneTps[T](aTp: T, bTps: List[T], lteFunc: (T, T) => Boolean) -----------
  private def lteOneTps(){
    salida.println("def lteOneTps[T](aTp: T, bTps: List[T], lteFunc: (T, T) => Boolean) = {")
    salida.println("  bTps.exists(bTp => lteFunc(aTp, bTp))")
    salida.println("}")
    
  }
  
//  //-----------------class ExampleReade() extends ExampleType-------------------------------
//  private def clases(name:Name, privileges:Privilegios, lattice:Lattice){
//    //Recorre cada privilegio
//	  for(i <- 0 to privileges.privs.length-1){
//	    //Si el privilegio es bottom
//	    if(privileges.privs.apply(i).anot.anot.tipo == lattice.bottom.bottom.anot.anot.tipo){
//			claseBottom(name, privileges.privs.apply(i))
//		}
//	    // si el privilegio no tiene generics
//	    else if(privileges.privs(i).gen.genericos.length==0){
//	      clasesSinGenerico(name, privileges.privs(i), privileges, lattice)
//	      salida.println()
//	    }
//  	    // si el privilegio tiene 1 generic
//	    else if(privileges.privs(i).gen.genericos.apply(0).inGenerico.length == 1){
//	      clasesCon1Generico(name, privileges.privs(i), privileges, lattice)
//	      salida.println()
//	    }
//   	    // si el privilegio tiene n generics
//	    else if(privileges.privs(i).gen.genericos.apply(0).inGenerico.length > 1)
//	    	clasesConNGenericos(name, privileges.privs(i), privileges, lattice)
//	        salida.println()
//	  }
//  }
  
   //-----------------class ExampleReade() extends ExampleType-------------------------------
  private def clases(name:Name, privileges:Privilegios, lattice:Lattice){
    //Recorre cada privilegio
	  for(i <- 0 to privileges.privs.length-1){
	    //Si el privilegio es bottom
	    if(privileges.privs.apply(i).anot.anot.tipo == lattice.bottom.bottom.anot.anot.tipo){
			claseBottom(name, privileges.privs.apply(i))
		}
	    // si el privilegio no tiene generics
	    else if(privileges.privs(i).gen.genericos.length==0){
	      clasesSinGenerico(name, privileges.privs(i), privileges, lattice)
	      salida.println()
	    }
//	    el privilegio tiene generics y es hijo
	    else if(tools.privilegioSubtipoEnLattice(privileges.privs.apply(i), lattice) != (-1)){
//	      Para la cabecera del metodo
	    	salida.println(cabezera(name, privileges.privs.apply(i)))
	    	salida.println("override def lte(b: "+name.name+"Type) = b match {")
//	    	para los case consigo mismo y sus padres
	    	  salida.println(tools.overridedDefLteRuntime(name, lattice, privileges.privs.apply(i), privileges, 2))
	    	salida.println("case _ => false")
	    	salida.println("}")
	    	salida.println(overrideToString(privileges.privs.apply(i)))
	    	salida.println("}")
	    }
//	    El privilegio tiene generics pero no tiene padres
	    else if(tools.privilegioSubtipoEnLattice(privileges.privs.apply(i), lattice) == (-1)){
	      //	      Para la cabecera del metodo
	    	salida.println(cabezera(name, privileges.privs.apply(i)))
	    	salida.println("override def lte(b: "+name.name+"Type) = b match {")
//	      Tiene un solo generic
	      if(privileges.privs.apply(i).gen.genericos.apply(0).inGenerico .length == 1){
	        salida.println("case bt: "+name.name+privileges.privs.apply(i).anot.anot.tipo.capitalize +" =>")
	        salida.println("tps.forall(lteOneTps(_, bt.tps, "+tools.getVarianza(privileges.privs.apply(i).gen.genericos.apply(0).inGenerico.apply(0))+"))")
//	        overrideToString(privileges.privs.apply(i))
	      }
//	        Tiene mas de un generic
	      else{
	        salida.println("case bt: "+name.name+privileges.privs.apply(i).anot.anot.tipo.capitalize +" =>")
	        var tpsForalls = new Array[String](privileges.privs.apply(i).gen.genericos.apply(0).inGenerico.length)
	        for(j<- 0 to privileges.privs.apply(i).gen.genericos.apply(0).inGenerico.length-1){
	        	tpsForalls(j)="tps._"+(j+1)+".forall(lteOneTps(_, bt.tps._"+(j+1)+", "+tools.getVarianza(privileges.privs.apply(i).gen.genericos.apply(0).inGenerico.apply(j))+"))"  
	        }
	        salida.println(tools.agregaSeparacion(tpsForalls, " && "))
	      }
	    	salida.println("case _ => false")
	    	salida.println("}")
	    	salida.println(overrideToString(privileges.privs.apply(i)))
	    	salida.println("}")
	    }
//	    tiene genericos, define el objeto de la clase
	    if(privileges.privs .apply(i).gen.genericos.length!=0)
	    salida.println(objectPrivilegio(name, privileges.privs.apply(i)))
	  }
  }

		//-------------------auxiliares class ExampleReade() extends ExampleType---------------

  	    	private def cabezera(name:Name, privilegio:Privilegio):String = {
//	    	Tiene 1 generic  
	    	  if(privilegio.gen.genericos.apply(0).inGenerico.length == 1)
	    	    "class "+name.name+privilegio.anot.anot.tipo.capitalize+"(val tps: List[Type]) extends "+name.name+"Type{"
	    	  else {
	    		var argumentos=auxReturnDeNGenericos(privilegio)
	    		"class "+name.name+privilegio.anot.anot.tipo.capitalize+"(val tps: ("+argumentos+")) extends "+name.name+"Type{"	    	    
	    	  }
	    	}
  
  	    	private def overrideToString(privilegio:Privilegio):String = {
  	    	  var toString="override def toString(): String = {"
//  	    	    El privilegio tiene un generic
  	    	    if(privilegio.gen .genericos .apply(0).inGenerico.length==1)
  	    	    	toString = toString+"return "+"""""""+privilegio.anot.anot.tipo+"[("+"""""""+"+(tps.map{tp => tp.toString}.mkString("+"""""""+","+"""""""+"))+"+"""""""+")]"+"""""""
//  	    	    El privilegio tiene mas de un generic
  	    	      else{
  	    	    	toString = toString+"return "+"""""""+privilegio.anot.anot.tipo +"[("+"""""""+"+"+AuxToStringNGenericos(privilegio)+"+"+"""""""+")]"+"""""""  	    	        
  	    	      }
  	    	  toString = toString+"}"
  	    	  toString
  	    	}
  	    	
  	    	private def objectPrivilegio(name:Name, privilegio:Privilegio):String = {
  	    	  var objetoAcompaniante=""
  	    	  if(privilegio.gen.genericos.apply(0).inGenerico.length==1)
  	    	    objetoAcompaniante = objetoAcompaniante+"object "+name.name+""+privilegio.anot.anot.tipo.capitalize+"{ def apply(tps: List[Type]) = new "+name.name+""+privilegio.anot.anot.tipo.capitalize+"(tps); def unapply(e: "+name.name+""+privilegio.anot.anot.tipo.capitalize+"): Option[List[Type]] = Some(e.tps)}"
  	    	    else{
  	    	      var argumentos=auxReturnDeNGenericos(privilegio)
  	    	      objetoAcompaniante = objetoAcompaniante+"object "+name.name+privilegio.anot.anot.tipo.capitalize+"{ def apply(tps: ("+argumentos+")) = new "+name.name+privilegio.anot.anot.tipo.capitalize+"(tps); def unapply(e: "+name.name+privilegio.anot.anot.tipo.capitalize+"): Option[("+argumentos+")] = Some(e.tps)}"
  	    	    }
  	    	  objetoAcompaniante
  	    	}
  
  
  		//-------------------auxiliar class privilegio bottom extends ExampleType---------------
  		private def claseBottom(name:Name, privilege:Privilegio){
  		  //Si no tiene generics
  		  if(privilege.gen .genericos .length==0){
  			  salida.println("class "+name.name+privilege.anot.anot.tipo.capitalize+"() extends "+name.name+"Type{")
  			  salida.println("override def lte(b: "+name.name+"Type) =  true")
  			  salida.println("override def toString(): String = {")
  			  salida.println("return "+"""""""+privilege.anot.anot.tipo+""""""")
  		  }
  		  //Si tiene 1 generic  			  
  		  else if(privilege.gen.genericos.apply(0).inGenerico.length==1){
  			  salida.println("class "+name.name+privilege.anot.anot.tipo.capitalize+"(val tps: List[Type]) extends "+name.name+"Type{")
  			  salida.println("override def lte(b: "+name.name+"Type) =  true")
  			  salida.println("override def toString(): String = {")
  			  salida.println("return "+"""""""+privilege.anot.anot.tipo+"[("+"""""""+"+(tps.map{tp => tp.toString}.mkString("+"""""""+","+"""""""+"))+"+"""""""+")]"+""""""")
  		  }
  		  //Si tiene mas de 1 generic   
  		  else if(privilege.gen.genericos.apply(0).inGenerico.length>1){
  		    var argumentos=auxReturnDeNGenericos(privilege)
			salida.println("class "+name.name+privilege.anot.anot.tipo.capitalize+"(val tps: ("+argumentos+")) extends "+name.name+"Type{")
  		    salida.println("override def lte(b: "+name.name+"Type) =  true")
  		    salida.println("override def toString(): String = {")
  		    salida.println("return "+"""""""+privilege.anot.anot.tipo +"[("+"""""""+"+"+AuxToStringNGenericos(privilege:Privilegio)+"+"+"""""""+")]"+""""""")
  		  }  		  
  		  salida.println("}")
  		  salida.println("}")
  		}

  		//-------------------auxiliar class privilegio sin generico extends ExampleType---------------
  		private def clasesSinGenerico(name:Name, privilege:Privilegio, privilegios:Privilegios, lattice:Lattice){
				salida.println("class "+name.name+privilege.anot.anot.tipo.capitalize+"() extends "+name.name+"Type{")
			//redefine lte
  				//si el privilegio es subtipo de otro				
				if(tools.privilegioSubtipoEnLattice(privilege,lattice)!=(-1)){
//					var padre=tools.latticeGetSuperTipo(privilege, lattice, privilegios)
					salida.println("override def lte(b: "+name.name+"Type) = b match {")
					// por default cada padre ser� con case true
					var padresPrivilegios=tools.getPadresPriv(lattice, privilege, privilegios)
					  salida.println("case bt: "+name.name+privilege.anot.anot.tipo.capitalize+" => true")
					for(z<- padresPrivilegios)
					  salida.println("case bt: "+name.name+z.anot.anot.tipo.capitalize+" => true")
					salida.println("case _ => false")
  					salida.println("}")
  				}
  				salida.println("override def toString(): String = {")
  				salida.println("return "+"""""""+privilege.anot.anot.tipo+""""""")
  				salida.println("}")
  				salida.println("}")
  				
  		}	

//  			-------------------auxiliar class privilegio con 1 generico extends ExampleType---------------
  		private def clasesCon1Generico(name:Name, privilege:Privilegio, privilegios:Privilegios, lattice:Lattice){
  			salida.println("class "+name.name+privilege.anot.anot.tipo.capitalize+"(val tps: List[Type]) extends "+name.name+"Type{")
  			//si el privilegio es subtipo de otro
  			if(tools.privilegioSubtipoEnLattice(privilege,lattice)!=(-1)){
  			  	//redefine lte
  			  salida.println("override def lte(b: "+name.name+"Type) = b match {")
  			  var padres=tools.getPadresPriv(lattice, privilege, privilegios)
  			 //Los padres no tienen el mismo numero de generics que el hijo 
  			  if(tools.genericsDeJerarquiaIguales(lattice, privilege, privilegios)==false){
  			    // case para el privilegio hijo
  			    salida.println("case bt: "+name.name+privilege.anot.anot.tipo.capitalize+" => true")
  				  // case para cada padre
  					for(x <- 0 to padres.length-1)
  						salida.println("case bt: "+name.name+padres.apply(x).anot.anot.tipo.capitalize+" => true")
  					salida.println("case _ => false")
  					salida.println("}")
  			  }
  			  // Los padres tienen el mismo numero de generics que el hijo	
  			  else{
  			    //redefine lte
//  			case para el privilegio hijo
  			    salida.println("case bt: "+name.name+privilege.anot.anot.tipo.capitalize+" => ")
  			    salida.println("tps.forall(lteOneTps(_, bt.tps, "+tools.getVarianza(privilege.gen.genericos.apply(0).inGenerico.apply(0))+"))")
  			    for(x <- 0 to padres.length-1){
  			    	salida.println("case bt: "+name.name+padres.apply(x).anot.anot.tipo.capitalize+" =>")
  			    	salida.println("tps.forall(lteOneTps(_, bt.tps, "+tools.getVarianza(padres.apply(x).gen.genericos.apply(0).inGenerico.apply(0))+"))")
  			    }
  			    salida.println("case _ => false")
  			    salida.println("}")
  			  }

  			}
 			  // el privilegio tiene generics pero no tiene padres
  			else if(privilege.gen.genericos.length!=0){
  			  salida.println("override def lte(b: "+name.name+"Type) = b match {")
  			  salida.println("case bt: "+name.name+privilege.anot.anot.tipo.capitalize+" => ")
  			  salida.println("tps.forall(lteOneTps(_, bt.tps, "+tools.getVarianza(privilege.gen.genericos.apply(0).inGenerico.apply(0))+"))")
  			  salida.println("case _ => false")
  			  salida.println("}")
  			}
  			salida.println("override def toString(): String = {")
  			salida.println("return "+"""""""+privilege.anot.anot.tipo+"[("+"""""""+"+(tps.map{tp => tp.toString}.mkString("+"""""""+","+"""""""+"))+"+"""""""+")]"+""""""")
  			salida.println("}")
  			salida.println("}")
  			salida.println("object "+name.name+""+privilege.anot.anot.tipo.capitalize+"{ def apply(tps: List[Type]) = new "+name.name+""+privilege.anot.anot.tipo.capitalize+"(tps); def unapply(e: "+name.name+""+privilege.anot.anot.tipo.capitalize+"): Option[List[Type]] = Some(e.tps)}")	
  		}	
  
// 			//-------------------auxiliar class privilegio con N genericos extends ExampleType---------------
  		private def clasesConNGenericos(name:Name, privilege:Privilegio, privilegios:Privilegios, lattice:Lattice){
  			var argumentos=auxReturnDeNGenericos(privilege)
			salida.println("class "+name.name+privilege.anot.anot.tipo.capitalize+"(val tps: ("+argumentos+")) extends "+name.name+"Type{")
  			//	si el privilegio es subtipo de otro
  			if(tools.privilegioSubtipoEnLattice(privilege,lattice)!=(-1)){
  			  	//sobreescribe lte()
  			  salida.println("override def lte(b: "+name.name+"Type) = b match {")
  			  var padres=tools.getPadresPriv(lattice, privilege, privilegios)
  			  //Los padres no tienen el mismo numero de generics que el hijo 
  			  if(tools.genericsDeJerarquiaIguales(lattice, privilege, privilegios) == false){
  			     // case para el privilegio hijo
  			    salida.println("case bt: "+name.name+privilege.anot.anot.tipo.capitalize+" => true")
  				  // case para cada padre
  					for(x <- 0 to padres.length-1)
  						salida.println("case bt: "+name.name+padres.apply(x).anot.anot.tipo.capitalize+" => true")
  					salida.println("case _ => false")
  					salida.println("}")
  			  }
  			  //Los padres tienen el mismo numero de generics que el hijo
  			  else{
  			    //redefine lte
//  			case para el privilegio hijo
  			    salida.println("case bt: "+name.name+privilege.anot.anot.tipo.capitalize+" => ")
  			    salida.println(AuxclasesConNGenericos(privilege))
  			    for(x <- 0 to padres.length-1){
  			       salida.println("case bt: "+name.name+""+padres.apply(x).anot.anot.tipo+" =>")
  			       salida.println(AuxclasesConNGenericos(padres.apply(x)))
  			    }
  			    salida.println("case _ => false")
  			    salida.println("}")
  			  }
  			}
			  // el privilegio tiene generics pero no tiene padres
  			else if(privilege.gen.genericos.length!=0){
  			  salida.println("override def lte(b: "+name.name+"Type) = b match {")
  			  salida.println("case bt: "+name.name+privilege.anot.anot.tipo.capitalize+" => ")
  			  salida.println(AuxclasesConNGenericos(privilege))
  			  salida.println("case _ => false")
  			  salida.println("}")
  			}
  			salida.println("override def toString(): String = {")
  			var a=AuxToStringNGenericos(privilege)
  			salida.println("return "+"""""""+privilege.anot.anot.tipo+"[("+"""""""+"+"+a+"+"+"""""""+")]"+""""""")
  			salida.println("}")
  			salida.println("}")
//   		var argumentos=auxReturnDeNGenericos(privilege)
  			salida.println("object "+name.name+privilege.anot.anot.tipo.capitalize+"{ def apply(tps: ("+argumentos+")) = new "+name.name+privilege.anot.anot.tipo.capitalize+"(tps); def unapply(e: "+name.name+privilege.anot.anot.tipo.capitalize+"): Option[("+argumentos+")] = Some(e.tps)}")
  		}

  				//-------------------auxiliares de auxiliar privilegio N Genericos extends ExampleType---------------
  		
  				private def AuxclasesConNGenericos(privilege:Privilegio):String={
  		  			var genericos=new Array[String](privilege.gen.genericos.apply(0).inGenerico.length)
  		  				for(i <- 0 to privilege.gen .genericos .apply(0).inGenerico .length-1){
  		  					genericos(i)="tps._"+(i+1)+".forall(lteOneTps(_, bt.tps._"+(i+1)+", "+tools.getVarianza(privilege.gen.genericos.apply(0).inGenerico.apply(i))+"))"
  		  				}
//      			for(i <- 0 to genericos.length-1)
//      	  		salida.println("los genericos: "+genericos(i))
  		  			return(tools.agregaSeparacion(genericos, " && "))
  		  		}
  
  		  		private def AuxToStringNGenericos(privilege:Privilegio):String={
  		  			var genericos=new Array[String](privilege.gen.genericos.apply(0).inGenerico.length)
  		  				for(i <- 0 to privilege.gen .genericos .apply(0).inGenerico .length-1){
  		  					genericos(i)="(tps._"+(i+1)+".map{tp => tp.toString}.mkString("+"""""""+","+"""""""+"))"
  		  				}
  		  			var a="+"+"""""""+"),("+"""""""+"+"
  		  		return(tools.agregaSeparacion(genericos, a))
  		  		}
  		  		
  		  		private def auxReturnDeNGenericos(privilege:Privilegio):String={
  		  			var genericos=new Array[String](privilege.gen.genericos.apply(0).inGenerico.length)
  		  				for(i <- 0 to privilege.gen .genericos .apply(0).inGenerico .length-1){
  		  					genericos(i)="List[Type]"
  		  				}
  		  			return tools.agregaSeparacion(genericos, ", ") 
  		  		}
  		  		
  			//-------------------auxiliar de auxiliares class privilegio extends ExampleType---------------
  			
  		  	private def genericosIguales(lattice:Lattice, privilege:Privilegio, privilegios:Privilegios):Boolean={
				var matrizConds=tools.condsToArreglo(lattice)
				var padresString=tools.getPadres(privilege.anot.anot.tipo, matrizConds)
				var padresPriv=tools.ordenaArregloPrivilegios(padresString, privilegios)
				var genericsEnPriv=new Array[Int](padresPriv.length)
				//obtiene el numero de generics del hijo
				var hijo=tools.cuentaGenerics(privilege)
				//salida.println("numero "+hijo)
				//obtiene el numero de generics de cada padre
				for(x <- 0 to padresPriv.length-1){
					genericsEnPriv(x) = tools.cuentaGenerics(padresPriv(x))
				}
				// comprueba que todos tengan el mismo numero de genericos
				var iguales = tools.genericosIguales(hijo, genericsEnPriv)
				return iguales
			}
  		  		
  			private def casebt(lattice:Lattice, privilegios:Array[Privilegio]){
  			  
  			}
    
  
    
  //--case class DominioEffect (tps: List[ExampleType] = Nil, override val unknown: Boolean = false) extends WithUnknownEffect -------------
  private def caseClassDominioEffect(name:Name){
 	  salida.println("case class "+name.name+"Effect(tps: List["+name.name+"Type] = Nil, override val unknown: Boolean = false) extends WithUnknownEffect {")
	  salida.println("def this(tp: "+name.name+"Type) = this(List(tp))")
	  salida.println("override def toString() = {")
	  salida.println("tps.map{tp => "+"""""""+"@"+"""""""+"+tp.toString()}.mkString("+"""""""+" " +"""""""+") + (if(unknown) " +""""""+"""""""+"+�"+"""""""+" else "+"""""""+"""""""+")")
	  salida.println("}")
	  salida.println("}") 
  }

  //----------------------------object DominioEffect---------------------------------------
  private def objectDominioEffect(name:Name){
	  salida.println("object "+name.name+"Effect {")
	  salida.println("def apply(tp: "+name.name+"Type) = new "+name.name+"Effect(tp)")
	  salida.println("}")
  }
  
  //----------------------------lazy val top: Effect = ---------------------------------------
  private def lazyTop(name:Name, privilegios:Privilegios, lattice:Lattice){
	  salida.println("lazy val top: Effect=")
	  exampleEffectTop(name, privilegios, lattice)
  }
  
  	//	----------------------------Auxiliares lazy val top: Effect = ---------------------------------------
  	private def exampleEffectTop(name:Name, privilegios:Privilegios, lattice:Lattice){
    //define el numero de elementos que hay en top
  		var tamano=lattice.top.privilegios.length
  			for(i<-0 to lattice.top.privilegios.length-1){
  				if(esBottom(lattice.top.privilegios(i), lattice))
  				tamano=tamano-1
  			}
  		var tops=new Array[String](tamano)
    //	por cada elemento de top
  		var contTop=0
  			for(i<- 0 to lattice.top.privilegios.length-1){
	    // 		excluye a bottom y toma los privilegios que no tienen generic
  				if(!esBottom(lattice.top.privilegios(i), lattice) && lattice.top.privilegios(i).gen.genericos.length==0){
  			// 	salida.println("new "+name.name+lattice.top.privilegios(i).anot.anot.tipo.capitalize)
  					tops(contTop)="new "+name.name+lattice.top.privilegios(i).anot.anot.tipo.capitalize
  					contTop=contTop+1
  				}
	      // 	excluye a bottom y toma los privilegios que tienen 1 generic
  				else if(!esBottom(lattice.top.privilegios(i), lattice) && lattice.top.privilegios(i).gen.genericos.apply(0).inGenerico.length==1){
//  					salida.println("el que llega tiene "+lattice.top.privilegios.apply(i).gen .genericos .apply(0).inGenerico.apply(0))
  					tops(contTop)=exampleEffectTop1Generico(name, privilegios, lattice.top.privilegios(i), lattice)
  					contTop=contTop+1
  				}
  				else if(!esBottom(lattice.top.privilegios(i), lattice) && lattice.top.privilegios(i).gen.genericos.apply(0).inGenerico.length>1){
  					var listas = exampleEffectTopNGenerico(name, privilegios, lattice.top.privilegios(i), lattice)
  					var listasComas=tools.agregaSeparacion(listas, ",")
  					tops(contTop)="new "+name.name+lattice.top.privilegios(i).anot.anot.tipo.capitalize+"(("+listasComas+"))"
  					contTop=contTop+1
  				}
  			}
	        salida.println(name.name+"Effect(List("+tools.agregaSeparacion(tops, ", ")+"))")
	}
  

  		// 	----------------Auxiliares del auxiliar lazy val top: Effect = -------------------------- 
  		private def esBottom(privilegio:Privilegio, lattice:Lattice):Boolean={
  			var bottom=false
  			for(i <- 0 to lattice.top.privilegios.length-1)
  				if(lattice.bottom.bottom.anot.anot.tipo == privilegio.anot.anot.tipo )
  					bottom=true
  			return bottom
  		}
  
  		//--------------------para privilegios top con 1 generico---------------------------------------
  		private def exampleEffectTop1Generico(name:Name, privilegios:Privilegios, privilegio:Privilegio, lattice:Lattice):String={
  			var priv=getPrivilegio(privilegios, privilegio)
  			var resultado=""
//  			  salida.println("generico valor del generico "+priv.gen.genericos.apply(0).inGenerico.apply(0))
	    // 	obtiene el tipo o subtipo del generico
//  			  salida.println(getTipoComp(name,priv.gen.genericos.apply(0).inGenerico.apply(0)))
  			resultado=priv.gen.genericos.apply(0).inGenerico.apply(0).compGenerico match{
//  			  case Some(a)=> salida.println("hace case asfda sdf asdf asd"); "si hace case"
  				case Some(a)=> ExampleEffectTopGenericoConComp(name, priv, getTipoComp(name,priv.gen.genericos.apply(0).inGenerico.apply(0)))
  				case None=> ExampleEffectTopGenericoSinComp(name, priv, getVarianza(name,priv.gen.genericos.apply(0).inGenerico.apply(0))) 
  			}
  			return "new "+name.name+priv.anot.anot.tipo.capitalize+"("+resultado+")"
  		}

  		//--------------------para privilegios top con N genericos---------------------------------------
  		private def exampleEffectTopNGenerico(name:Name, privilegios:Privilegios, privilegio:Privilegio, lattice:Lattice):Array[String]={
  			var priv=getPrivilegio(privilegios, privilegio)
  			var resultado=new Array[String](priv.gen.genericos.apply(0).inGenerico .length)
      // 	por cada generico en el privilegio
  				for(i<- 0 to priv.gen .genericos .apply(0).inGenerico.length-1){
//        		salida.println("tipo "+priv.gen.genericos.apply(0).inGenerico.apply(i).tipo .tipo)
  					resultado(i)=priv.gen.genericos.apply(0).inGenerico.apply(i).compGenerico match{
  						case Some(a)=> ExampleEffectTopGenericoConComp(name, priv, getTipoComp(name,priv.gen.genericos.apply(0).inGenerico.apply(i)))
  						case None=> ExampleEffectTopGenericoSinComp(name, priv, getVarianza(name,priv.gen.genericos.apply(0).inGenerico.apply(i))) 
  					}
  				}
  			return resultado
			// salida.println("resultado "+resultado(0))
  			// salida.println("resultado "+resultado(1))
  		}
  
  			// ----------Obtiene la referencia del privilegio definido en la seccion "privileges"------------
  			private def getPrivilegio(privilegios:Privilegios, privilegio:Privilegio):Privilegio={
  				var priv=privilegio
  				for(i <- 0 to privilegios.privs.length-1)
  					if(privilegios.privs(i).anot.anot.tipo==privilegio.anot.anot.tipo)
  					priv=privilegios.privs(i)
  				return priv
  			}

  			// ----------------------------el generico no tiene comp----------------------------------------
  			private def getVarianza(name:Name, inGenerico:InGenerico):String={
  				var varianza=""
  				inGenerico.varianza match{
  					case Some(a)=>a
  					case None=>"no le asigna en getVarianza"
  				} 
  				//    if(varianza == "-")
  				//      salida.println("new "+name.name+privilegio.anot.anot.tipo.capitalize +"(List(definitions.NothingClass.tpe))")
  				//    else
  				//      salida.println("new "+name.name+privilegio.anot.anot.tipo.capitalize +"(List(definitions.AnyClass.tpe))")
  			}
  
  			
  			// -------------------------------el generico tiene comp------------------------------------------
  			private def getTipoComp(name:Name, inGenerico:InGenerico):String={
  				var tipoComp=""
//  				  salida.println(inGenerico.compGenerico)
  				inGenerico.compGenerico match{
  					case Some(a) => a.location.location.apply(0)
  					case None => "no le asigna en getTipoComp"
  				} 
  				//	  salida.println("new "+name.name+privilegio.anot.anot.tipo.capitalize+"(List(definitions."+tipoComp+"Class.tpe))")
  			}
  			// -------------------------------Lista de tipos cuando no hay comparacion------------------------
  			private def ExampleEffectTopGenericoSinComp(name:Name, priv:Privilegio, varianza:String):String={
  				if(varianza == "-")
  					"List(definitions.NothingClass.tpe)"
  				else
  					"List(definitions.AnyClass.tpe)"
  			}
  			// -------------------------------Lista de tipos cuando si hay comparacion------------------------  
  			private def ExampleEffectTopGenericoConComp(name:Name, priv:Privilegio, tipo:String):String={
  				"List(definitions."+tipo+"Class.tpe)"
  			}

  
  //----------------------------lazy val bottom: Effect = ---------------------------------------  			
  private def lazybottom(name:Name, privilegios:Privilegios, lattice:Lattice){
	if(lattice.bottom .bottom .gen .genericos.length==0){
	  salida.println("lazy val bottom: Effect = "+name.name+"Effect(List(new "+name.name+lattice.bottom.bottom.anot.anot.tipo.capitalize+"))")
	}
	else if(lattice.bottom .bottom .gen .genericos.apply(0).inGenerico.length==1){
	  salida.println("lazy val bottom: Effect = "+name.name+"Effect(List("+exampleEffectTop1Generico(name, privilegios, lattice.bottom.bottom, lattice)+"))")
	}
	else if(lattice.bottom.bottom.gen.genericos.apply(0).inGenerico.length>1){
	  var listas = exampleEffectTopNGenerico(name, privilegios, lattice.bottom.bottom, lattice)
	  salida.println("lazy val bottom: Effect = "+name.name+"Effect(List(new "+name.name+lattice.bottom.bottom.anot.anot.tipo.capitalize+"(("+tools.agregaSeparacion(listas, ", ")+"))))")
	}
  }
  
  //----------------------------lazy val unknown: Effect = ---------------------------------------
  private def lazyUnknown(name:Name, privilegios:Privilegios, lattice:Lattice){
    if(lattice.bottom .bottom .gen .genericos.length==0){
	  salida.println("lazy val unknown: Effect = new "+name.name+"Effect(List(new "+name.name+lattice.bottom.bottom.anot.anot.tipo.capitalize+"), true)")
	}
	else if(lattice.bottom .bottom .gen .genericos.apply(0).inGenerico.length==1){
	  salida.println("lazy val unknown: Effect = new "+name.name+"Effect(List("+exampleEffectTop1Generico(name, privilegios, lattice.bottom.bottom, lattice)+"), true)")
	}
	else if(lattice.bottom.bottom.gen.genericos.apply(0).inGenerico.length>1){
	  var listas = exampleEffectTopNGenerico(name, privilegios, lattice.bottom.bottom, lattice)
	  salida.println("lazy val unknown: Effect = new "+name.name+"Effect(List(new "+name.name+lattice.bottom.bottom.anot.anot.tipo.capitalize+"(("+tools.agregaSeparacion(listas, ", ")+"))), true)")
	}
//    salida.println("lazy val unknown: Effect = new "+name.name+"Effect(List(new "+name.name+lattice.bottom.bottom.anot.anot.tipo.capitalize+"), true)")
  }  

  //------------------------------------def default = bottom--------------------------------------------------
  private def defDefault(){
    salida.println("def default = bottom")
  }
  
  //------------------------------------def lte(a: Effect, b: Effect): Boolean--------------------------------
  private def defLte(){
    salida.println("def lte(a: Effect, b: Effect): Boolean = {")
    salida.println("lteUnknown(a,b) ||")
    salida.println("a.tps.forall(lteOne(_, b))")
    salida.println("}")
  }
  
  //------------------------------------def lteOne(a: Effect, b: Effect): Boolean--------------------------------
  private def defLteOne(name:Name, lattice:Lattice){
    salida.println("def lteOne(aTp: "+name.name+"Type, b: Effect): Boolean = aTp match{")
    salida.println("case _: "+name.name+lattice.bottom.bottom.anot.anot.tipo.capitalize+" => true")
    salida.println("case _ => b.tps.exists(bTp => aTp.lte(bTp))")
    salida.println("}")
  }

  //-------------def lteOneOne(aTp: ExampleType, bTp: ExampleType): Boolean --------------------------------
  private def defLteOneOne(name:Name){
    salida.println("def lteOneOne(aTp: "+name.name+"Type, bTp: "+name.name+"Type): Boolean = aTp.lte(bTp)")
  }
  
  //-----------------------------def elimSub(aTps: List[ExampleType]) ----------------------------------------
  private def elimSub(name:Name){
     salida.println("def elimSub(aTps: List["+name.name+"Type]): List["+name.name+"Type] = aTps match {")
     salida.println("case Nil => Nil")
     salida.println("case t :: ts =>")
     salida.println("val (subtypes, others) = ts.partition(t1 => lteOneOne(t1, t))")
     salida.println("val rest = elimSub(others)")
     salida.println("if (rest.exists(t1 => lteOneOne(t, t1))) rest")
     salida.println("else t :: rest")
     salida.println("}")
   }

  //-----------------------------def elimSub(aTps: List[ExampleType]) ----------------------------------------
  private def revoke(name:Name){
	  salida.println("def revoke(aTps: List["+name.name+"Type], tp: "+name.name+"Type): List["+name.name+"Type] = {")
	  salida.println("aTps.filterNot(t => lteOneOne(t,tp))")
	  salida.println("}")
  }

  //-----------------------------def join(a: Effect, b: Effect): Effect----------------------------------------
  private def join(name:Name){
     salida.println("def join(a: Effect, b: Effect): Effect = {")
     salida.println("val tps = if(a <= bottom) b.tps")
     salida.println("else if(b <= bottom) a.tps")
     salida.println("else a.tps ++ b.tps")
     salida.println(name.name+"Effect(elimSub(tps), joinUnknown(a,b))")
     salida.println("}")
   }
   
  private def meet(name:Name){   
	  salida.println("def meet(a: Effect, b: Effect): Effect = {")
	  salida.println("val keepA = a.tps.filter(lteOne(_, b))")
	  salida.println("val keepB = b.tps.filter(lteOne(_, a))")
	  salida.println("val aNotB = keepA.filterNot(aTp => keepB.exists(bTp => aTp.lte(bTp)))")
	  salida.println(name.name+"Effect(aNotB ++ keepB, meetUnknown(a,b))")
	  salida.println("}")	  
  }
 
  private def diff(name:Name){
    salida.println("def diff(a: Effect, b: Effect): Effect = {")
    salida.println("val valid = a.tps.filter(!lteOne(_, b))")
    salida.println(name.name+"Effect(elimSub(valid))")
    salida.println("}")
  }
 
  private def getStrictPrivileges(name:Name){
    salida.println("def getStrictPrivileges(eff: Effect): Effect = {")
    salida.println(name.name+"Effect(eff.tps)")
    salida.println("}")
  }
  
  private def getStrictPrivilegesTree(name: Name, privilegios:Privilegios){
    salida.println("def getStrictPrivilegesTree(eff: Effect): List[scala.tools.nsc.Global#Tree] = {")
    salida.println("eff.tps.flatMap{ tp => tp match{")
    //recorre cada privilegio
    for(i <- 0 to privilegios.privs.length-1){
//      el privielegio no tiene generics
      salida.println()
     if(privilegios.privs.apply(i).gen .genericos.length==0){
       salida.println("case _: "+name.name+privilegios.privs.apply(i).anot.anot.tipo.capitalize+" => List(reify{scala.annotation.effects."+privilegios.privs .apply(i).anot.anot.tipo.capitalize+"()}.tree)")
     }
//     el privilegio tiene 1 generic      
     else if(privilegios.privs.apply(i).gen .genericos.apply(0).inGenerico.length == 1){
       salida.println("case "+name.name+privilegios.privs.apply(i).anot.anot.tipo +"(tps) =>")
       salida.println("val lists = List(")
       salida.println("Apply(Ident(reify{List}.tree.symbol), tps.map{tp => Literal(Constant(tp.toString()))})")
       salida.println(")")
       salida.println("if(eff.tps.size>0)")
       salida.println("List(Apply(Select(Ident(reify{scala.annotation.effects.runtime"+privilegios.privs.apply(i).anot.anot.tipo+"}.tree.symbol), newTermName("+"""""""+"apply"+""""""""+")),")
       salida.println("List(Apply(Ident(reify{List}.tree.symbol), lists))))")
       salida.println("else List[Tree]()")
     }
//     el privilegio tiene mas de 1 generic
     else if(privilegios.privs.apply(i).gen .genericos.apply(0).inGenerico.length > 1){
       salida.println("case "+name.name+privilegios.privs.apply(i).anot.anot.tipo +"(tps) =>")
       salida.println("val lists = List(")
       salida.println(applyIdentReify(privilegios.privs.apply(i).gen.genericos.apply(0)))
       salida.println(")")
       salida.println("if(eff.tps.size>0)")
       salida.println("List(Apply(Select(Ident(reify{scala.annotation.effects.runtime"+privilegios.privs.apply(i).anot.anot.tipo+"}.tree.symbol), newTermName("+"""""""+"apply"+""""""""+")),")
       salida.println("List(Apply(Ident(reify{List}.tree.symbol), lists))))")
       salida.println("else List[Tree]()")
     }
    }
    salida.println("}")
    salida.println("}.toList")
    salida.println("}")
  }
//  para la definicion de "Apply(Ident(reify..."
  	private def applyIdentReify(genericos:Generico):String = {
  	  var applies= new Array[String](genericos.inGenerico.length)
//	  recorre cada generico
  	  for(i <- 0 to genericos.inGenerico.length-1)
  	    applies(i)= "Apply(Ident(reify{List}.tree.symbol), tps._"+(i+1)+".map{tp => Literal(Constant(tp.toString()))})"
  	  return tools.agregaSeparacion(applies, ", ")
	}
}