//Las diferencias entre example(check               e               infer)
//	domain=>				override def adjust					override def computeEffectImpl
//	Lattice=>	def getStrictPrivilegesTree(eff: Effect)			No tiene

package parser

import scala.util.matching.Regex
import scala.util.parsing.combinator.syntactical._
import scala.io._
import interpreter._
import tools._
import scala.annotation.Annotation

object Parser extends StandardTokenParsers {
	lexical.reserved += ("grant", "check", "revoke", "trust", "restrict", "privileges", "def", "call", "within", "if", "top", "bottom", "pointcuts", "lattice", "uncheck", "name", "loc", "add", "set", "remove", "prod", "ann")
	lexical.delimiters += (":", ".", ",", "@", "(", ")", "=>", "[", "]", "<", "&","||", "?", "=:=", "<:", "+", "-", "*", "...")

	//-----------------------test----------------------------------

//	def uncheck1 = new lexical.Scanner ("uncheck : def println()") 
//	println(args.apply(0))


	/*def main(args: Array[String]) = {
    //loadFile("myIo.prg")
	  loadFile(args.apply(0))
	}*/

  def loadFile(file: String) = {
    val input = Source.fromFile(file).getLines.reduceLeft[String](_ + '\n' + _)
    val tokens = new lexical.Scanner(input)

    val result = phrase(program)(tokens)


    result match {
      case Success (tree, _) => new Interpreter1(tree).run
      case e => System.out.println(e)
    }
  }
	
	def program = stmt+ 
	def stmt:Parser[Statement] = (name ~ privileges ~ lattice ~ disciplines ~ (unchecks?))^^ {case a~b~c~d~e => Program(a,b,d,c,e)}
//	def program = (privileges )

//-----------------------checked section---------------------------
	def operador = ( ("=:="|">:"|"<:")^^ {case a=> Operador(a)})
	
//-----------------------checked section---------------------------	
	def uncheckOpt = (location <~ (","?)  ^^ {case a=> UnLoc(a)})
				
	def uncheck = (uncheckOpt) ^^{case a => Uncheck(a)}
	
	def unchecks = ("uncheck" ~> ":") ~> rep(uncheck) ^^ {case a => Unchecks(a)} 

//-----------------------name section---------------------------
	
	def name = ("name"~>":"~>ident) ^^ {case a => Name(a.capitalize)}
	
//-----------------------privileges section---------------------------

	
	
//	def tipo = (ident)^^{case a => Type(a)} 
	
	def tipo = rep1(ident <~ ("."?)) ^^{case a => Type(convierteTipoAString(a))}
	
	private def convierteTipoAString(tipo:List[String]):String ={
	  var tools = new Tools()
    var cadenas=new Array[String](tipo.length)
	  for(i <- 0 to tipo.length-1)
	      cadenas(i)=tipo(i)
	  tools.agregaSeparacion(cadenas, ".") 
	} 
	  
	def genericos = rep(generico) ^^ {case a => Genericos(a)}
	
	def compGenerico =  (operador) ~ (tipo) ^^ {case a~b => CompGenerico(a,b)}
	
	def inGenerico = (("+"|"-")?) ~ tipo ~ (comp?) <~ (","?) ^^ {case a~b~c => InGenerico(a,b,c)}
	
	def generico = (("[" ~> rep(inGenerico) <~ "]") ^^ {case a => Generico(a)})
	
	def anotacion = (("@"~>  tipo)^^ {case a => Anotacion(a)})        
	
	def priv = (((anotacion) ~ genericos)^^{case a ~ b => Privilegio(a,b)})
	
	def privileges = (("privileges" ~ ":" ~> rep1(priv))^^ {case a => Privilegios(a)})

	
//-----------------------discipline section---------------------------
	
	def operation = ("check" | "grant" | "revoke" | "trust" | "restrict" | "add" | "set" | "remove" | "ann" | "prod")^^{case a=>Operation(a)}
	
	def privs = rep1(priv)^^ {case a => Privilegios(a)}
	
	def discipline = ((pointcut) ~ operation ~ rep1(priv) ~ (rep(within)))^^{case a~b~c~d=>Pointcut(a,b,c,d)}
	
	def disciplines = ("pointcuts"~>":"~>rep1(discipline))^^{case a=> Pointcuts(a)}
	
	//-----------------------pointcut section-----------------------------

//	//returnType //0 or 1-----------------------------
	def ret = ((":" ~> tipo) ^^ { case a => Ret(a)})
	
	def returnType = ((ret ~ (genericos?) ~ (comp?)) ^^ { case a~b~c => ReturnType(a,b,c)})

	//argumentos //0 or 1-----------------------------
						
	def comp = ( (operador~location)^^{case a~b=>CompLocation(a,b)}
	           | (operador~location)^^{case a~b=>CompLocation(a,b)})
	           
//	def 
//				  |(operador~ident)^^{case a~b => CompArg()})   
	def argumento = ((tipo)~(comp?)<~(","?)^^{case a~b => Argumento(a,b)})
	def argumentos = (rep(argumento) <~ ("..."?) ^^{case a => Argumentos(a, true)}
				   | rep(argumento) ^^ {case a=>Argumentos(a, false)})
	
	//funName-----------------------------
	
//	def funcionDef = ("def"~> (location <~ "*") ~ (generico?) ~ (("(" ~> (argumentos) <~ ")" )?) ~ (returnType?)  ^^ {case a~b~c~d => FunctionDef(a,b, c,d, true)}
//				| "def"~> location ~ (generico?) ~ (("(" ~> (argumentos) <~ ")")?) ~ (returnType?) ^^ { case  a ~ b ~ c ~ d => FunctionDef(a, b, c, d, false)}) 
	
	def funcionDef = ("def" ~> location ~ (generico?) ~ (("(" ~> (argumentos) <~ ")" )?) ~ (returnType?) ^^  {case a~b~c~d => FunctionDef(a,b, c,d, true)})
				   
	def funcionCall = ("call"~> location ~ (generico?) ~  (("(" ~> (argumentos) <~ ")" )?) ~ (returnType?) ^^ {case a~b~c~d => FunctionCall(a,b, c,d, true)})
//	def funcionCall= ("call"~> (location <~ "*") ~ (generico?) ~ (("(" ~> (argumentos) <~ ")" )?) ~ (returnType?)  ^^ {case a~b~c~d => FunctionCall(a,b, c,d, true)}
//				| "call"~> location ~ (generico?) ~ (("(" ~> (argumentos) <~ ")")?) ~ (returnType?) ^^ { case  a ~ b ~ c ~ d => FunctionCall(a, b, c, d, false)})
				
	
				
//	def funcion=(funcionDef|funcionCall)

	//call-----------------------------
//	def call = ("call"~>funcion)

	//point-----------------------------
	def point = ((funcionDef)^^{case a =>Point(a)}
			  |	(funcionCall)^^{case a =>Point(a)})

  	// loc-----------------------------

//	def location = ( (rep1(ident<~("."?))<~(".*")<~(".")) ~ (rep1(ident)<~("*"?))^^{case a ~ b=>Location(a++b, true, true)}
//					|rep1(ident<~("."?))<~(".*")^^{case a=>Location(a,true, false)}
//					|rep1(ident<~("."?))^^{case a=>Location(a,false, false)})
					
	def location = rep1(loc) ^^ {case a => Location(a, true ,true)}
					
	def loc = ( "." | "*" | ident  )   
	
	
	// within-----------------------------

	def locations = ("("?)~>(rep1(location<~(("||")?)))<~(")"?) ^^ {case a => Locations(a)}
	def within = "within" ~> locations ^^ {case a => Within(a)}
	
			  
	//pointcut-----------------------------			  
			  
	def pointcut =(((point)~(rep(within)))^^{case a~b=> Joinpoint(a,b)})

				 
//-----------------------Lattice section---------------------------
	//top-------------------------------------
	
	def top = ("top"~>":"~>rep1(priv))^^{case a => Top(a)}
			  			 
	//bottom------------------------------------						 
	
	def bottom = ("bottom"~>":"~>priv)^^{case a=>Bottom(a)}
	
	//condition
	
	def relacion = (priv ~(operador)~ priv) ^^{case a~b~c=>Compara(a,b,c)}
	
	//Lattice---------------------------------------
	def lattice = ("lattice"~>":"~>(top ~ bottom ~ rep(relacion))) ^^ {case a~b~c => Lattice(a,b,c)}
}


abstract class Statement
	//-----------------------------------------------------------------------------
//------------------------------------case program--------------------------------------------------
case class Program(nombre: Name, privilegios:Privilegios, disciplina:Pointcuts, lattice:Lattice, uncheck: Option[Unchecks]) extends Statement


//	//--------------------------------seccion Operador---------------------------------------------
case class Operador(operador:String)

//	//--------------------------------seccion Name---------------------------------------------
case class Name(name:String) extends Statement

//	//--------------------------------seccion privilegios---------------------------------------------
case class CompGenerico(operador:Operador, tipo:Type)
case class Type(tipo:String) 
case class Genericos(genericos:List[Generico])
case class Generico(inGenerico:List[InGenerico])//{val res = gen match{case Some(a)=>a case None=>()}}
case class InGenerico(varianza:Option[String], tipo:Type, compGenerico:Option[Comp])
case class Anotacion(anot:Type){val res=anot}
case class Privilegio(anot:Anotacion, gen:Genericos)
case class Privilegios(privs:List[Privilegio]) extends Statement//{for(i<-0 to privs.length-1)println(privs.apply(i).anot.res  +" "+privs.apply(i).gen.res)}


//--------------------------------seccion Pointcut---------------------------------------------	

//	//--------------------------------case within---------------------------------------------
case class Locations(location:List[Location])
case class Within(location:Locations)

//		//--------------------------------case location---------------------------------------------
case class Location(location:List[String], comodin:Boolean, comoodinMedio:Boolean)


//	//------------------------------------case returnType--------------------------------------------------
case class Ret(ret: Type)
case class ReturnType(ret: Ret, gen:Option[Genericos], comp: Option[Comp]){}

//	//------------------------------------case argumento--------------------------------------------------

abstract class Comp(){
  val operador:Operador=null
//	  val tipo:Type=null
  val location:Location=null
} 
//	case class CompTipo(override val operador:Operador, override val tipo:Type)extends Comp()
case class CompLocation(override val operador:Operador, override val location:Location)extends Comp()
case class Argumento(argumento:Type, operacion:Option[Comp]) //
case class Argumentos(argumentos:List[Argumento], argsVariables:Boolean) //

//	//------------------------------------case funcion--------------------------------------------------	
//	case class Fun(fun:String)

case class Point(funcion:Function)

abstract class Function(){
	var clase:Location
	var generico:Option[Generico]
	var arg:Option[Argumentos]
	var returnType:Option[ReturnType]
	var comodin:Boolean
}

case class FunctionDef(override var clase:Location, override var generico: Option[Generico], override var arg:Option[Argumentos], override var returnType:Option[ReturnType], override var comodin:Boolean) extends Function()//{ clase match{case Some(clase)=>println(clase.clase)
//																														case None => println("no clase")} 
//																											arg match{case Some(arg)=>println(arg.argumento)
//																														case None=> println("no argumentos")}
//																											 returnType match{case Some(returnType)=>println(returnType.gen +returnType.ret.ret)
//																											 				  case None=>println("sin retorno")}
//																											}

case class FunctionCall(override var clase:Location, override var generico: Option[Generico], override var arg:Option[Argumentos], override var returnType:Option[ReturnType], override var comodin:Boolean) extends Function()

//	//------------------------------------case call--------------------------------------------------
//	case class Call(function: FunctionDef)

//	//------------------------------------case pointcut--------------------------------------------------
case class Joinpoint(point:Point, within:List[Within])
//------------------------------------case operation--------------------------------------------------	
case class Operation(operacion:String)

//------------------------------------case Discipline--------------------------------------------------
case class Pointcut(joinpoint:Joinpoint, operation:Operation, priv:List[Privilegio], withins: List[Within])//{println(pointcut+" "+operation+" "+privs)}
case class Pointcuts(pointcuts:List[Pointcut]) extends Statement

//------------------------------------SeccLattice--------------------------------------------------

//------------------------------------case top--------------------------------------------------

case class Top(privilegios:List[Privilegio])

//------------------------------------case bottom--------------------------------------------------
case class Bottom(bottom:Privilegio)


//------------------------------------case condition--------------------------------------------------
//	case class Cond(privilege1:Privilegio, privilege2:Privilegio)
case class Compara(op1:Privilegio, operador:Operador, op2:Privilegio)
//	case class IfPart(ident1:String, op:Compara, ident2:String)
//	case class Condition(condition:Cond, ifPart:Option[IfPart])//{println(condition.privilege1 +" "+condition.privilege2 +" " + ifPart.toString() )}
//	case class Conditions(conditions:List[Condition])

//------------------------------------case lattice--------------------------------------------------
case class Lattice(top:Top, bottom:Bottom, comparation:List[Compara])extends Statement //{println(top+""+bottom+""+""+comparation)}

//------------------------------------case uncheck--------------------------------------------------
abstract class UncheckAny(){
  val location:Location = null
  val function:FunctionDef = null
}
case class UnLoc(override val location:Location) extends UncheckAny 
case class UnFun(override val function:FunctionDef) extends UncheckAny
case class Uncheck(uncheck:UncheckAny)//{println(uncheck.toString())}
case class Unchecks(unchecks:List[Uncheck])extends Statement{}