package tools

import parser._

class Correctness {
  
	def isCorrect(nombre: Name, privilegios:Privilegios, disciplina:Pointcuts, lattice:Lattice):Boolean={
		if(   disciplines(privilegios, disciplina) 
		    + latticeTop(privilegios, lattice) 
		    + latticeBottom(privilegios:Privilegios, lattice.bottom:Bottom)
		    + latticeComp1(privilegios, lattice)
		    + latticeComp2(privilegios, lattice)
		    == 0){
//				println("correcto")
				true
		}
		else{
//				println("incorrecto")
				false
		}
	}
  
	private def disciplines(privilegios:Privilegios, discipline:Pointcuts):Int = {
	  var error=0
//	recorre cada disciplina
	  for(disciplina<- discipline.pointcuts)
//	  recorre cada privilegio definido en la disciplina
	    for(privilegio<- disciplina.priv){
	    	if(!isPrivDefinido(privilegio, privilegios)){
          if(!isUnknwon(privilegio)){
            println("El privilegio @"+ privilegio.anot.anot.tipo+" de la seccion Disciplines no se definio")
  //	    	  println(privilegio.anot.anot.tipo)
            error = error+1
          }
	    	}
	    	else{
//	    	  println("si lo encuentra")
//	    	  println(privilegio.anot.anot.tipo )
	    	}
	    }
	  error
	} 
	
//	recorre cada privilegio de top
	private def latticeTop(privilegios:Privilegios, lattice:Lattice):Int = {
	  var error=0
	  for(top<- lattice.top.privilegios)
	    if(!isPrivDefinido(top, privilegios)){
	        println("El privilegio @"+ top.anot.anot.tipo+" de la seccion lattice/Top no se definio")
//	    	println(top.anot.anot.tipo)
	    	error=error+1
	    }
	    else{
//	      println("si lo encuentra")
//	      println(top.anot.anot.tipo )
	    }
	  error
	}
	
	private def latticeBottom(privilegios:Privilegios, bottom:Bottom):Int={
	  var error=0
	  if(!isPrivDefinido(bottom.bottom, privilegios)){
	    println("El privilegio @"+ bottom.bottom.anot.anot.tipo+" de la seccion lattice/Bottom no se definio")
//	    println(bottom.bottom.anot.anot.tipo)
	    error=error+1
	  }
	  else{
//		  println("si lo encuentra")
//	      println(bottom.bottom.anot.anot.tipo )
	  }
	  error
	}
	
	private def latticeComp1(privilegios:Privilegios, lattice:Lattice):Int = {
	  var error=0
	  for(linea<- lattice.comparation )
	   if(!isPrivDefinido(linea.op1 , privilegios)){

        println("El privilegio @"+ linea.op1.anot.anot.tipo+" de la seccion lattice/subtipos no se definio")
  //	    println(linea.op1.anot.anot.tipo)
        error=error+1

	  }
	  else{
//		  println("si lo encuentra")
//	      println(linea.op1.anot.anot.tipo )
	  }
	  error
	}

	private def latticeComp2(privilegios:Privilegios, lattice:Lattice):Int = {
	  var error=0
	  for(linea<- lattice.comparation )
	   if(!isPrivDefinido(linea.op2 , privilegios)){

        println("The privilege @"+ linea.op1.anot.anot.tipo+" is not defined")
  //	    println(linea.op2.anot.anot.tipo)
        error=error+1

	  }
	  else{
//		  println("si lo encuentra")
//	      println(linea.op2.anot.anot.tipo )
	  }
	  error
	}

  private def isUnknwon(privilegio: Privilegio): Boolean = {
    privilegio.anot.anot.tipo == "unknown"
  }
	
	//	devuelve false si no encuentra el privilegio en la seccion de definicion 
		private def isPrivDefinido(privilegio:Privilegio, privilegios:Privilegios):Boolean = {
		  var encontrado=false
		  for(x<- privilegios.privs){
//		    El privilegio de la disciplina no tiene generics
		    if(privilegio.gen.genericos .length==0){
		    	if(x.anot.anot.tipo == privilegio.anot.anot.tipo && x.gen .genericos.length==0){
		    		encontrado=true
		    	}
		    }
		    else{
		      if(x.gen .genericos.length > 0 && x.anot.anot.tipo == privilegio.anot.anot.tipo && x.gen.genericos.apply(0).inGenerico .length == privilegio.gen.genericos.apply(0).inGenerico.length){
		    	  encontrado=true
		      }
		    }
		  }
		  encontrado
		}
}