package tools

object lattice{
  case class LatticeGraph(){

    var nodes: List[LatticeNode] = List[LatticeNode]()

    var nodeMaps: Map[String, LatticeNode] = Map[String, LatticeNode]()

    /* name1 <: name2 */
    def addRelation(name1: String, name2: String) = {
      val node2 = nodeMaps.get(name2).getOrElse{
        val newNode = LatticeNode(name2)
        nodeMaps += (name2 -> newNode)
        newNode
      }

      val node1 = nodeMaps.get(name1).getOrElse{
        val newNode = LatticeNode(name1)
        nodeMaps += (name1 -> newNode)
        newNode
      }

      node1.parents = node1.parents :+ node2
    }

    def getNodes: List[LatticeNode] = {
      nodeMaps.map{case (key, node) => node}.toList
    }

    def getSuperTypes(node: LatticeNode, processed: List[LatticeNode] = List[LatticeNode]()): List[LatticeNode] = {
  
      node.parents.foldLeft(List[LatticeNode]()){case (l, n) =>
        /*println("analizando padre de ",node.name, n.name)
        if(processed.contains(n)){
          println("procesados:",processed.map{_.name})
          println(n)
          throw new Exception("Error: Circular reference")
        }*/
        val pr = (l ++ node.parents).toSet.toList
        l ++ List(n) ++ getSuperTypes(n, pr)
      }.toSet.toList
    }
  }

  case class LatticeNode(name: String, var parents: List[LatticeNode] = List[LatticeNode]()){

  }

//  def main(args: Array[String]): Unit = {
//    val lattice = LatticeGraph();
//
//    //A <: B
//    lattice.addRelation("A", "B")
//    //B <: C
//    lattice.addRelation("B", "C")
//    //A <: D
//    lattice.addRelation("A", "D")
//    //D <: C
//    lattice.addRelation("D", "C")
//    //B <: F
//    lattice.addRelation("E", "F")
//
//    var nodo=(-1)
//    for(i<- 0 to lattice.getNodes.length-1)
//      if(lattice.getNodes.apply(i).name=="D")
//    	nodo=i   
//    	println(nodo)
//    
//    
//    
//    for(i<- 0 to lattice.getSuperTypes(lattice.getNodes.apply(nodo)).length-1)
//    	println("El padre es "+lattice.getSuperTypes(lattice.getNodes.apply(nodo)).apply(i).name)
//    	println()
//    	println()
//    	lattice.getNodes.map{ node => 
//    	println("For node "+ node.name + ": " + lattice.getSuperTypes(node).map{_.name}.mkString(", "))
//    }
//
//  }
}