package effectchecker
import scala.tools.nsc.Global

abstract class AppDomain extends EffectDomain {
  import global._
  val lattice: AppLattice = new AppLattice{
    val global: AppDomain.this.global.type = AppDomain.this.global
  }
  import lattice._
  lazy val annotationClasses: List[Symbol] = List()

  def parseAnnotationInfos(annots: List[AnnotationInfo], default: => Effect): Effect =
    default


}
abstract class AppLattice extends EffectLattice {
  val global: Global
  import global._

  type Effect = AppEffect
  val ctEvidence = implicitly[scala.reflect.ClassTag[Effect]]

  case class AppEffect() extends WithUnknownEffect{
    override def toString() = {
      "@app"
    }
  }

  def join(a: Effect, b: Effect): Effect = a
  def meet(a: Effect, b: Effect): Effect = a
  def lte(a: Effect, b: Effect): Boolean = true
  def diff(a: Effect, b: Effect): Effect = bottom
  def default = AppEffect()

  //def check(tree: Tree, eff: Effect) = true
  def top: Effect    = AppEffect()
  def bottom: Effect = AppEffect()
  val unknown: Effect = new AppEffect() {override val unknown = true}

  def getStrictPrivileges(eff: Effect): Effect = {
    bottom
  }

  def getStrictPrivilegesTree(eff: Effect): List[Tree] = {
    List[Tree]()
  }

  type OverrideEffect = NeededEffect
  val ctEvidenceOverrideEffect = implicitly[scala.reflect.ClassTag[OverrideEffect]]
  case class NeededEffect(e: Effect)

  def constructNeededEffect(e: Effect): OverrideEffect = NeededEffect(e)
}
