package filters

import play.api.i18n.Lang
import play.api.mvc.{Result, RequestHeader, Filter}
import scala.concurrent.Future
import play.api.Play.current
import scala.concurrent.ExecutionContext.Implicits.global

object LangFilter extends Filter {
  def apply(f: (RequestHeader) => Future[Result])(rh: RequestHeader): Future[Result] = {
    f(rh).map { result =>

      Lang.availables.find(_.language == rh.session.get("lang").getOrElse(None)) match {
        case Some(_) => result.withLang(Lang(rh.session.get("lang").get))
        case None => result.withLang(Lang("es"))
      }

      //result.withLang(Lang("es")) //Lang(rh.session.get("lang").getOrElse("es")))
    }
  }
}