package models

import play.api.db.slick.Config.driver.simple._
import java.sql.Timestamp
import play.api.Play.current
import play.api.cache.Cache

case class Car(id: Option[Long],
                model: String,
                year: Int
                 )


/** Table definition for Cars. */
class Cars(tag: Tag) extends Table[Car](tag, "usuario") {
  def id = column[Long]("id", O.PrimaryKey, O.AutoInc)
  def model = column[String]("rut")
  def year = column[Int]("clave")


  def * = (id.?, model, year) <> (Car.tupled, Car.unapply)
}


object Cars extends DatabaseClient[Car] {

  type DBTable = Cars
  val all = database.withSession { implicit db: Session =>
    TableQuery[DBTable]
  }

  def insert(u: Car) = database.withSession { implicit db: Session =>
    (all returning all.map(_.id)) += u
  }


}

