package models

import play.api.db.slick.Config.driver.simple._
import java.sql.Timestamp
import play.api.Play.current
import play.api.cache.Cache

case class User(id: Option[Long],
                name: String,
                password: String
                )


/** Table definition for users. */
class Users(tag: Tag) extends Table[User](tag, "user") {
  def id = column[Long]("id", O.PrimaryKey, O.AutoInc)
  def name = column[String]("name")
  def password = column[String]("password")


  def * = (id.?, name, password) <> (User.tupled, User.unapply)
}


object Users extends DatabaseClient[User] {

  type DBTable = Users
  val all = database.withSession { implicit db: Session =>
    TableQuery[DBTable]
  }

  override def byId(id: Long): Option[User] = database.withSession { implicit db: Session =>
    all.filter( x => x.id === id).list.headOption
  }

  def insert(u: User) = database.withSession { implicit db: Session =>
    (all returning all.map(_.id)) += u
  }

  def byName(name: String): List[User] = database.withSession { implicit db: Session =>
    all.filter( x => x.name === name).list
  }

}

