package util
import play.api.mvc.MultipartFormData.FilePart
import java.io.File
import play.api.Play


object FileUploader {
	def upload[TemporaryFile](parts: FilePart[play.api.libs.Files.TemporaryFile], folder: String, fname: String = "") = {
    val filename = if(fname.size>0) fname else parts.filename

    val mainFolderName = Play.current.configuration.getString("upload.folder").getOrElse("uploads")
    val fullpath = mainFolderName+s"/$folder/$filename"
    val mainFolder = new File(mainFolderName)
    if (!mainFolder.exists)
      try {
        mainFolder.mkdir()
      } catch {
        case _: SecurityException => error("wrong permissions")
      }
    val tFolder = new File(mainFolderName+s"/$folder")
    if (!tFolder.exists)
      try {
        tFolder.mkdir()
      } catch {
        case _: SecurityException => error("wrong permissions")
      }
    val name = fullpath.substring(0, fullpath.lastIndexOf("."))
    val extension = fullpath.substring(fullpath.lastIndexOf(".") + 1)

    val file = searchNonUsedFilename(name, extension)

    parts.ref.moveTo(file)
    file
	}
  def delete(file: String) = {
    val f = new File(file)
    if(f.exists())
      f.delete()
  }
	
	def searchNonUsedFilename(filename: String, extension: String, i: Int = 0): File = {
	  val name = if(i>0) filename+s"($i)" else filename
	  val file = new File(if(extension.size>0) s"$name.$extension" else name)
	  if(file.exists()){
	    searchNonUsedFilename(filename, extension, i+1)
	  }
	  else{
	    file
	  }
	}
}