# --- Created by Slick DDL
# To stop Slick DDL generation, remove this comment and start using Evolutions

# --- !Ups

create table "aerodromo" ("id" BIGINT GENERATED BY DEFAULT AS IDENTITY(START WITH 1) NOT NULL PRIMARY KEY,"designador_oaci" VARCHAR NOT NULL,"designador_iata" VARCHAR,"latitud" DOUBLE NOT NULL,"longitud" DOUBLE NOT NULL,"parking_capacity" INTEGER);
create table "COMMENTS" ("id" BIGINT GENERATED BY DEFAULT AS IDENTITY(START WITH 1) NOT NULL PRIMARY KEY,"TEXT" VARCHAR NOT NULL,"AUTHOR" BIGINT NOT NULL,"DATE" TIMESTAMP NOT NULL);
create table "compania_aerea" ("id" BIGINT GENERATED BY DEFAULT AS IDENTITY(START WITH 1) NOT NULL PRIMARY KEY,"compania_aerea" VARCHAR NOT NULL,"abreviacion" VARCHAR NOT NULL);
create table "itinerary" ("id" BIGINT GENERATED BY DEFAULT AS IDENTITY(START WITH 1) NOT NULL PRIMARY KEY,"company_id" BIGINT NOT NULL,"year" INTEGER NOT NULL,"month" INTEGER NOT NULL,"date" TIMESTAMP NOT NULL,"comments" VARCHAR NOT NULL,"file" VARCHAR,"state" BOOLEAN);
create table "itinerary_flight" ("id" BIGINT GENERATED BY DEFAULT AS IDENTITY(START WITH 1) NOT NULL PRIMARY KEY,"itinerary_id" BIGINT NOT NULL,"callsign" VARCHAR NOT NULL,"from" TIMESTAMP NOT NULL,"to" TIMESTAMP NOT NULL,"freq" VARCHAR NOT NULL,"etd" VARCHAR NOT NULL,"eta" VARCHAR NOT NULL,"aircraft" VARCHAR NOT NULL,"departure" VARCHAR NOT NULL,"destination" VARCHAR NOT NULL,"state" INTEGER NOT NULL);
create table "itinerary_user_company" ("id" INTEGER GENERATED BY DEFAULT AS IDENTITY(START WITH 1) NOT NULL PRIMARY KEY,"user_id" BIGINT NOT NULL,"company_id" BIGINT NOT NULL);
create table "usuario" ("id" BIGINT GENERATED BY DEFAULT AS IDENTITY(START WITH 1) NOT NULL PRIMARY KEY,"rut" VARCHAR NOT NULL,"clave" VARCHAR NOT NULL,"nombre" VARCHAR NOT NULL,"apellido_paterno" VARCHAR,"apellido_materno" VARCHAR,"email" VARCHAR NOT NULL,"fono" VARCHAR,"pregunta_secreta" VARCHAR,"respuesta_secreta" VARCHAR,"created_at" TIMESTAMP,"updated_at" TIMESTAMP,"remember_key" VARCHAR,"token" VARCHAR,"estado" INTEGER NOT NULL,"sac_unit" VARCHAR);
create table "aip_node" ("id" BIGINT GENERATED BY DEFAULT AS IDENTITY(START WITH 1) NOT NULL PRIMARY KEY,"node" VARCHAR NOT NULL,"node_id" BIGINT,"slug" VARCHAR NOT NULL,"file" VARCHAR,"content" VARCHAR,"content_html" VARCHAR,"is_visible" BOOLEAN NOT NULL,"is_private" BOOLEAN NOT NULL,"order" INTEGER NOT NULL,"state" INTEGER NOT NULL,"updated_at" TIMESTAMP NOT NULL,"user_id" BIGINT NOT NULL);
alter table "COMMENTS" add constraint "COMMENTS_AUTHOR_FK" foreign key("AUTHOR") references "usuario"("id") on update NO ACTION on delete NO ACTION;
alter table "itinerary" add constraint "itinerary_company_fk" foreign key("company_id") references "compania_aerea"("id") on update NO ACTION on delete NO ACTION;
alter table "itinerary" add "departure_approval" BOOLEAN NULL;
alter table "itinerary" add "arrival_approval" BOOLEAN NULL;
alter table "itinerary_flight" add constraint "Itinerary_flight_itinerary_fk" foreign key("itinerary_id") references "itinerary"("id") on update NO ACTION on delete NO ACTION;
alter table "itinerary_user_company" add constraint "Itinerary_user_company_user_fk" foreign key("user_id") references "usuario"("id") on update NO ACTION on delete NO ACTION;
alter table "itinerary_user_company" add constraint "Itinerary_user_company_company_fk" foreign key("company_id") references "compania_aerea"("id") on update NO ACTION on delete NO ACTION;
alter table "aip_node" add constraint "aip_node_user_fk" foreign key("user_id") references "usuario"("id") on update NO ACTION on delete NO ACTION;

create table "mb_mail" ("id" BIGINT GENERATED BY DEFAULT AS IDENTITY(START WITH 1) NOT NULL PRIMARY KEY,"body_html" TEXT,"body_text" TEXT,"created_at" TIMESTAMP,"subject" VARCHAR(255),"strfrom" VARCHAR(255),"reply_to" VARCHAR(255));
create table "mb_mailto" ("id" BIGINT GENERATED BY DEFAULT AS IDENTITY(START WITH 1) NOT NULL PRIMARY KEY,"mail_id" BIGINT NOT NULL,"mailto" VARCHAR,"created_at" TIMESTAMP NOT NULL,"sent_at" TIMESTAMP,"tries" INTEGER,"error" TEXT,"state" BOOLEAN);
alter table "mb_mailto" add constraint "mb_mailto_mail_fk" foreign key("mail_id") references "mb_mail"("id") on update NO ACTION on delete NO ACTION;


CREATE TABLE "itinerary_user_aerodrome"
(
"id" BIGINT GENERATED BY DEFAULT AS IDENTITY(START WITH 1) NOT NULL PRIMARY KEY,
"user_id" BIGINT NOT NULL,
"airport_id" BIGINT NOT NULL,
);

CREATE TABLE "itinerary_protected_time" ("id" BIGINT GENERATED BY DEFAULT AS IDENTITY(START WITH 1) NOT NULL PRIMARY KEY, "start_time" TIMESTAMP NOT NULL, "end_time" TIMESTAMP NOT NULL, "aerodrome" VARCHAR(4) NOT NULL);

alter table "itinerary_user_aerodrome" add constraint "itinerary_user_fk" foreign key("user_id") references "usuario"("id") on update NO ACTION on delete NO ACTION;
alter table "itinerary_user_aerodrome" add constraint "airport_fk" foreign key("airport_id") references "aerodromo"("id") on update NO ACTION on delete NO ACTION;
# --- !Downs

alter table "COMMENTS" drop constraint "COMMENTS_AUTHOR_FK";
alter table "itinerary" drop constraint "itinerary_company_fk";
alter table "itinerary_flight" drop constraint "Itinerary_flight_itinerary_fk";
alter table "itinerary_user_company" drop constraint "Itinerary_user_company_user_fk";
alter table "itinerary_user_company" drop constraint "Itinerary_user_company_company_fk";
alter table "aip_node" drop constraint "aip_node_user_fk";
drop table "aerodromo";
drop table "COMMENTS";
drop table "compania_aerea";
drop table "itinerary";
drop table "itinerary_flight";
drop table "itinerary_user_company";
drop table "usuario";
drop table "aip_node";

alter table "itinerary_flight" add column "observations" text NULL;
alter table "itinerary" add column "user_id" BIGINT;

alter table "aerodromo" add column "service_hour_from" varchar(4);
alter table "aerodromo" add column "service_hour_to" varchar(4);

