# --- !Ups
CREATE TABLE "notam" (
"id" integer PRIMARY KEY AUTO_INCREMENT NOT NULL,
"serie" varchar(15),
"notam_type" varchar(2),
"serie_rc" varchar(15),
""fir"" varchar(10),
"notam_code" varchar(5),
"traffic" varchar(2),
"purpose" varchar(5),
"scope" varchar(5),
"lower_limit" varchar(5),
"upper_limit" varchar(5),
"coordinates" varchar(20),
"optional_group" varchar(20),
"item_a" varchar(255),
"item_b" varchar(255),
"item_c" varchar(255),
"item_d" varchar(255),
"item_e" longtext,
"item_f" varchar(255),
"item_g" varchar(255),
"item_h" varchar(255),
"item_i" varchar(255),
"item_j" varchar(255),
"item_k" varchar(255),
"item_l" varchar(255),
"item_m" varchar(255),
"item_n" varchar(255),
"item_p" varchar(255),
"item_r" varchar(255),
"item_s" varchar(255),
"item_t" varchar(255),
"status" integer,
"notam_text" longtext,
"category" integer
);

CREATE TABLE "msg_amhs_s"
(
    "id" serial NOT NULL,
    "ci" VARCHAR(3),
    "csn" VARCHAR(4),
    "time" VARCHAR(6),
    "priority" VARCHAR(2),
    "destination" TEXT,
    "source_time" VARCHAR(6),
    "header" TEXT,
    "text" TEXT,
    "created_at" TIMESTAMP,
    "state" INTEGER,
    "fpl_id" INTEGER,
    PRIMARY KEY (id)
);

CREATE TABLE "msg_amhs_r"
(
    "id" serial NOT NULL,
    "ci" VARCHAR(3),
    "csn" VARCHAR(4),
    "time" VARCHAR(6),
    "header" TEXT,
    "text" TEXT,
    "created_at" TIMESTAMP,
    "state" INTEGER,
    PRIMARY KEY (id)
);

create table "notam_msg_amhs_s" (
"id" integer primary key auto_increment not null,
"notam_id" integer not null,
"msg_amhs_s_id" integer not null,
CONSTRAINT notam_msg_id_fk  FOREIGN KEY (notam_id) REFERENCES notam(id) ON DELETE CASCADE
CONSTRAINT msg_amhs_s_id_fk  FOREIGN KEY (msg_amhs_s_id) REFERENCES msg_amhs_s(id) ON DELETE CASCADE

);

create table "distribution_lists" (
"id" serial NOT NULL,
"name" varchar(255),
"addresses" text);


CREATE TABLE "distribution_lists_serie"(
    "id" INTEGER PRIMARY KEY AUTO_INCREMENT NOT NULL,
    "distribution_list_id" INTEGER NOT NULL,
    "serie" VARCHAR(15) NOT NULL,
    "automatic" BOOLEAN NOT NULL DEFAULT FALSE
);



create table "distribution_lists_msg_amhs_s"(
"id" serial not null,
"distribution_list_id" integer not null,
"msg_amhs_s_id" integer not null,
foreign key ("distribution_list_id") references "distribution_lists"("id"),
foreign key ("msg_amhs_s_id") references "msg_amhs_s"("id")
)

create table "notam_selection_criteria"(
"id" INTEGER PRIMARY KEY AUTO_INCREMENT NOT NULL,
"code1" VARCHAR(2) NOT NULL,
"code2" VARCHAR(2) NOT NULL,
"scope" VARCHAR(3) NOT NULL,
"traffic" VARCHAR(2) NOT NULL DEFAULT '',
"purpose" VARCHAR(4) NOT NULL DEFAULT ''
)

CREATE TABLE "notam_db_message" (
"id" integer PRIMARY KEY AUTO_INCREMENT NOT NULL,
"request_type" varchar(1) NOT NULL,
""fir"" varchar(4) NOT NULL,
"request" longtext,
"response_header" varchar(255),
"response_text" longtext
)

alter table "notam" add column "originator" VARCHAR(255) NOT NULL DEFAULT '';
alter table "notam" add column "created_at" TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP;
alter table "notam" add column "updated_at" TIMESTAMP DEFAULT CURRENT_TIMESTAMP;
alter table "notam" add column "hash_value" VARCHAR(255) NOT NULL DEFAULT '';
alter table "notam" add column "user_id" INTEGER;
alter table "notam" add column "location" VARCHAR(255);
alter table "notam" add column "issuance" VARCHAR(255);


alter table "notam_db_message" add column "originator" VARCHAR(8) NOT NULL;
alter table "notam" add column "parked" boolean default false;


CREATE TABLE "notam_historical"
(
    "id" serial NOT NULL,
    "notam_id" integer,
		"notam_text" TEXT,
    "hash_value" VARCHAR(255),
  	"created_at" TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP,
   	"user_id" integer,
  	CONSTRAINT notam_msg_id_fk  FOREIGN KEY ("notam_id") REFERENCES "notam"("id") ON DELETE CASCADE,
    CONSTRAINT user_id_fk  FOREIGN KEY ("user_id") REFERENCES "usuario"("id") ON DELETE CASCADE
);


CREATE TABLE "fir" (
    "id" integer NOT NULL,
    "fir" character varying(255),
    "nombre" character varying(255),
    "latitude" float,
    "longitude" float
);



insert into "fir" ("id", "fir", "nombre") values (1, 'SCCZ', 'Punta Arenas');
insert into "fir" ("id", "fir", "nombre") values (1, 'SCEZ', 'Santiago');
insert into "fir" ("id", "fir", "nombre") values (1, 'SCFZ', 'Antofagasta');
insert into "fir" ("id", "fir", "nombre") values (1, 'SCTZ', 'Puerto Montt');
insert into "fir" ("id", "fir", "nombre") values (1, 'SCIZ', 'Isla de Pascua');



# METARS
CREATE TABLE metar
(
  id BIGINT GENERATED BY DEFAULT AS IDENTITY(START WITH 1) NOT NULL PRIMARY KEY,
  fir varchar(4) NOT NULL,
  hora varchar(6),
  glosa text,
  estado integer,
  csn integer,
  fecha_mensaje timestamp,
  categoria integer
)


# --- !Downs

drop table "notam_msg_amhs_s";
drop table "notam";

drop table "msg_amhs_s";
drop table "msg_amhs_r";

drop table "distribution_lists";

drop table "notam_historical";
