create table "aip_node" (
"id" BIGINT GENERATED BY DEFAULT AS IDENTITY(START WITH 1) NOT NULL PRIMARY KEY,
"node" VARCHAR NOT NULL,
"node_id" BIGINT,
"slug" VARCHAR NOT NULL,
"file" VARCHAR,
"content" VARCHAR,
"content_html" VARCHAR,
"is_visible" BOOLEAN NOT NULL,
"is_private" BOOLEAN NOT NULL,
"order" INTEGER NOT NULL,
"state" INTEGER NOT NULL,
"updated_at" TIMESTAMP NOT NULL,
"user_id" BIGINT NOT NULL);



create table "aip_aic" ("id" BIGINT GENERATED BY DEFAULT AS IDENTITY(START WITH 1) NOT NULL PRIMARY KEY,
"node_id" BIGINT NOT NULL,
"series" VARCHAR NOT NULL,
"number" INTEGER,
"year" INTEGER);

alter table "aip_aic" add constraint "aip_aic_fk" foreign key("node_id") references "aip_node"("id") on update CASCADE on delete CASCADE;


create table "aip_sup" ("id" BIGINT GENERATED BY DEFAULT AS IDENTITY(START WITH 1) NOT NULL PRIMARY KEY,
"node_id" BIGINT NOT NULL,
"section_affected" VARCHAR NULL,
"from" TIMESTAMP NOT NULL,
"to" TIMESTAMP,
"number" INTEGER,
"year" INTEGER);

alter table "aip_sup" add constraint "aip_sup_fk" foreign key("node_id") references "aip_node"("id") on update CASCADE on delete CASCADE;

alter table "aip_node" add column "tpe" INTEGER NOT NULL default 0;
alter table "aip_node" add column "published_on" TIMESTAMP;
alter table "aip_node" add column "effective_on" TIMESTAMP;

alter table "aip_node" modify column "node" varchar null;

alter table "aip_sup" modify column "section_affected" varchar null;






DROP TABLE IF EXISTS aip_node CASCADE;

CREATE TABLE aip_node
(
    id serial NOT NULL,
    node VARCHAR(255),
    node_id INTEGER,
    slug VARCHAR(255) NOT NULL,
    file VARCHAR(255),
    content TEXT,
    content_html TEXT,
    is_visible BOOLEAN NOT NULL,
    is_premium BOOLEAN NOT NULL,
    is_title BOOLEAN NOT NULL,
    "order" INTEGER NOT NULL,
    state INTEGER NOT NULL,
    updated_at TIMESTAMP,
    user_id INTEGER,
    is_image BOOLEAN,
    tpe INTEGER DEFAULT 0 NOT NULL,
    published_on TIMESTAMP,
    effective_on TIMESTAMP,
    PRIMARY KEY (id)
);



ALTER TABLE aip_node ADD CONSTRAINT aip_node_FK_1
    FOREIGN KEY (node_id)
    REFERENCES aip_node (id)
    ON DELETE CASCADE;

ALTER TABLE aip_node ADD CONSTRAINT aip_node_FK_2
    FOREIGN KEY (user_id)
    REFERENCES usuario (id)
    ON DELETE SET NULL;



DROP TABLE IF EXISTS aip_aic CASCADE;

CREATE TABLE aip_aic
(
    id serial NOT NULL,
    node_id INTEGER,
    series VARCHAR(255) NOT NULL,
    number INTEGER,
    year INTEGER,
    PRIMARY KEY (id)
);

-----------------------------------------------------------------------
-- aip_sup
-----------------------------------------------------------------------

DROP TABLE IF EXISTS aip_sup CASCADE;

CREATE TABLE aip_sup
(
    id serial NOT NULL,
    node_id INTEGER,
    section_affected VARCHAR(255),
    "from" TIMESTAMP,
    "to" TIMESTAMP,
    number INTEGER,
    year INTEGER,
    PRIMARY KEY (id)
);

ALTER TABLE aip_aic ADD CONSTRAINT aip_aic_FK_1
    FOREIGN KEY (node_id)
    REFERENCES aip_node (id)
    ON DELETE CASCADE;

ALTER TABLE aip_sup ADD CONSTRAINT aip_sup_FK_1
    FOREIGN KEY (node_id)
    REFERENCES aip_node (id)
    ON DELETE CASCADE;


insert into aip_node
(id, node, node_id, slug, file, content, content_html, is_visible, is_premium, "order",
state, updated_at, user_id, is_title, is_image, published_on, effective_on, tpe)
values
(1, 'AIP', null, 'aip', null,null, '', true, false, 0, 1, '2014-03-03 15:08:33', 2, true, false, null, '2014-03-01 00:00:00', 0),
(2, 'AMDT', null, 'amdt', null,null, '', true, false, 0, 1, '2014-03-03 15:08:33', 2, true, false, null, '2014-03-01 00:00:00', 0),
(3, 'SUP', null, 'sup', null,null, '', true, false, 0, 1, '2014-03-03 15:08:33', 2, true, false, null, '2014-03-01 00:00:00', 2),
(4, 'AIC', null, 'aic', null,null, '', true, false, 0, 1, '2014-03-03 15:08:33', 2, true, false, null, '2014-03-01 00:00:00', 3)
;
ALTER SEQUENCE aip_node_id_seq RESTART WITH 4;
